import c4d

import os

from c4d import documents, plugins, bitmaps, gui

PLUGIN_ID = 1029425 # test only - change to 1029425

#enums:
group1_profile = 999
group2_settings = 998
group3_options = 997
group4_buttons = 996
prof_txt = 1000
prof_combo = 1001
prof_circle = 10011
prof_square = 10012
prof_nside = 10013
prof_star = 10014
prof_flower = 10015
prof_custom = 10016
rad_txt = 1002
rad_value = 1003
rad_inner_txt = 1009
rad_inner_value = 1010
sides_txt = 1011
sides_value = 1012
edge_txt = 1006
edge_value =1007
keep_source = 1008
btn_ok = 1005
btn_canc = 1004
set_default = 1016
custom_prof_link = 1013
custom_prof_txt = 1014
ctrl_spline=1015


splineList = None
version = c4d.GetC4DVersion()
doc=documents.GetActiveDocument()



def IsSpline(obj):
	if (obj.GetRealSpline() or (obj.GetTypeName()=="MoSpline") or (obj.GetTypeName()=="Tracer")):
		return True
	else:
		return False
		

# check if there are selected objects and all are splines.
# return True, False or Error
def checkSelected(obj_list): 

	spline_count = 0
	
	if not obj_list:
		error = "error"
		return error

	if type(obj_list).__name__ == "list":
		tot = len(obj_list)
		for obj in obj_list:
			if IsSpline(obj):
				spline_count = spline_count+1
		if spline_count < tot :
			return False
		else:
			return True
	else:
		if obj_list.GetRealSpline() or obj_list.GetTypeName() == "MoSpline" or obj_list.GetTypeName()=="Tracer":
			return True
		else:
			return False
		
		
def setProfile(dati):
	doc=documents.GetActiveDocument()
	
	if dati['profile_id']==10011:
		profilo = c4d.BaseObject(c4d.Osplinecircle)
		profilo[c4d.PRIM_CIRCLE_RADIUS]=dati['rad']
		if dati['ctrl_spline']:
			doc.InsertObject(profilo)
			doc.AddUndo(c4d.UNDOTYPE_NEW,profilo)
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_ControlSpline"
			istanza = c4d.BaseObject(c4d.Oinstance)
			istanza[c4d.INSTANCEOBJECT_LINK]=profilo
			return istanza
		else:
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_profile"
			return profilo
	if dati['profile_id']==10012:
		profilo = c4d.BaseObject(c4d.Osplinerectangle)
		profilo[c4d.PRIM_RECTANGLE_WIDTH]=dati['edge']
		profilo[c4d.PRIM_RECTANGLE_HEIGHT]=dati['edge']
		if dati['ctrl_spline']:
			doc.InsertObject(profilo)
			doc.AddUndo(c4d.UNDOTYPE_NEW,profilo)
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_ControlSpline"
			istanza = c4d.BaseObject(c4d.Oinstance)
			istanza[c4d.INSTANCEOBJECT_LINK]=profilo
			return istanza
		else:
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_profile"
			return profilo
	if dati['profile_id']==10013:
		profilo = c4d.BaseObject(c4d.Osplinenside)
		profilo[c4d.PRIM_NSIDE_RADIUS] = dati['rad']
		profilo[c4d.PRIM_NSIDE_SIDES] = dati['sides']
		if dati['ctrl_spline']:
			doc.InsertObject(profilo)
			doc.AddUndo(c4d.UNDOTYPE_NEW,profilo)
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_ControlSpline"
			istanza = c4d.BaseObject(c4d.Oinstance)
			istanza[c4d.INSTANCEOBJECT_LINK]=profilo
			return istanza
		else:
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_profile"
			return profilo
	if dati['profile_id']==10014:
		profilo = c4d.BaseObject(c4d.Osplinestar)
		profilo[c4d.PRIM_STAR_ORAD] = dati['rad']
		profilo[c4d.PRIM_STAR_IRAD] = dati['inner_rad']
		profilo[c4d.PRIM_STAR_POINTS] = dati['sides']
		if dati['ctrl_spline']:
			doc.InsertObject(profilo)
			doc.AddUndo(c4d.UNDOTYPE_NEW,profilo)
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_ControlSpline"
			istanza = c4d.BaseObject(c4d.Oinstance)
			istanza[c4d.INSTANCEOBJECT_LINK]=profilo
			return istanza
		else:
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_profile"
			return profilo
	if dati['profile_id']==10015:
		profilo = c4d.BaseObject(c4d.Osplineflower)
		profilo[c4d.PRIM_FLOWER_ORAD] = dati['rad']
		profilo[c4d.PRIM_FLOWER_IRAD] = dati['inner_rad']
		profilo[c4d.PRIM_FLOWER_PETALS] = dati['sides']
		if dati['ctrl_spline']:
			doc.InsertObject(profilo)
			doc.AddUndo(c4d.UNDOTYPE_NEW,profilo)
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_ControlSpline"
			istanza = c4d.BaseObject(c4d.Oinstance)
			istanza[c4d.INSTANCEOBJECT_LINK]=profilo
			return istanza
		else:
			profilo[c4d.ID_BASELIST_NAME]=profilo.GetName()+"_profile"
			return profilo


def make_sweep(dati):
	doc=documents.GetActiveDocument()
	doc.StartUndo()
	c4d.CallCommand(100004767) #deselect all

	if dati.has_key('custom_spline'):
		sez=dati['custom_spline'].GetClone()
		
		if dati['ctrl_spline']:
			sez[c4d.ID_BASELIST_NAME]=sez.GetName()+"_ControlSpline"
			doc.InsertObject(sez)
			doc.AddUndo(c4d.UNDOTYPE_NEW,sez)
			to_delete = dati['custom_spline']
			doc.AddUndo(c4d.UNDOTYPE_DELETE,to_delete)
			to_delete.Remove()
			istanza = c4d.BaseObject(c4d.Oinstance)
			istanza[c4d.INSTANCEOBJECT_LINK]=sez
			sez = istanza
	else:
		sez = setProfile(dati)
		sez[c4d.ID_BASELIST_NAME]=sez.GetName()+"_CustomProfile"
		
	# BEGIN LOOP
	# qui sez è una spline o un istanza
	
	for spline in splineList:
	
 		prof = sez.GetClone()
		
		sweep = c4d.BaseObject(c4d.Osweep)
		sweep[c4d.ID_BASELIST_NAME] = "Sweep_"+spline.GetName()
		
		tracciato = spline.GetClone()
		phong = c4d.BaseTag(c4d.Tphong)
		phong[c4d.PHONGTAG_PHONG_ANGLELIMIT]=True
		phong[c4d.PHONGTAG_PHONG_ANGLE]=c4d.utils.Rad(58)
		phong[c4d.PHONGTAG_PHONG_USEEDGES]=True
		
		doc.InsertObject(sweep)
		doc.AddUndo(c4d.UNDOTYPE_NEW,sweep)
		
		if dati['keep_source']==True:
			tracciato.InsertUnder(sweep)
			tracciato[c4d.ID_BASELIST_NAME] = tracciato.GetName()+"_path"
			prof.InsertUnder(sweep)
			sweep.InsertTag(phong)
		else:
			doc.AddUndo(c4d.UNDOTYPE_CHANGE,spline)
			spline[c4d.ID_BASELIST_NAME] = spline.GetName()+"_path"
			spline.InsertUnder(sweep)
			prof.InsertUnder(sweep)
			sweep.InsertTag(phong)
	doc.EndUndo()
	c4d.EventAdd()


# DIALOG

class QuickSweepDlg(gui.GeDialog):

		def __init__(self):
			self.AddGadget(c4d.DIALOG_NOMENUBAR, 0)#disable menubar

		def UpdateDlg(self, id):			
			if id==prof_circle:
				self.Enable(rad_txt,True)
				self.Enable(rad_value,True)
				self.Enable(edge_txt,False)
				self.Enable(edge_value,False)
				self.Enable(rad_inner_value,False)
				self.Enable(rad_inner_txt,False)
				self.Enable(sides_txt,False)
				self.Enable(sides_value,False)
				self.Enable(custom_prof_txt,False)
				self.Enable(custom_prof_link,False)
			elif id==prof_square:
				self.Enable(edge_txt,True)
				self.Enable(edge_value,True)
				self.Enable(rad_txt,False)
				self.Enable(rad_value,False)
				self.Enable(rad_inner_value,False)
				self.Enable(rad_inner_txt,False)
				self.Enable(sides_txt,False)
				self.Enable(sides_value,False)
				self.Enable(custom_prof_txt,False)
				self.Enable(custom_prof_link,False)
			elif id==prof_nside:
				self.Enable(edge_txt,False)
				self.Enable(edge_value,False)
				self.Enable(rad_txt,True)
				self.Enable(rad_value,True)
				self.Enable(rad_inner_value,False)
				self.Enable(rad_inner_txt,False)
				self.Enable(sides_txt,True)
				self.Enable(sides_value,True)
				self.Enable(custom_prof_txt,False)
				self.Enable(custom_prof_link,False)
			elif id==prof_star:
				self.Enable(edge_txt,False)
				self.Enable(edge_value,False)
				self.Enable(rad_txt,True)
				self.Enable(rad_value,True)
				self.Enable(rad_inner_value,True)
				self.Enable(rad_inner_txt,True)
				self.Enable(sides_txt,True)
				self.Enable(sides_value,True)
				self.Enable(custom_prof_txt,False)
				self.Enable(custom_prof_link,False)
			elif id==prof_flower:
				self.Enable(edge_txt,False)
				self.Enable(edge_value,False)
				self.Enable(rad_txt,True)
				self.Enable(rad_value,True)
				self.Enable(rad_inner_value,True)
				self.Enable(rad_inner_txt,True)
				self.Enable(sides_txt,True)
				self.Enable(sides_value,True)
				self.Enable(custom_prof_txt,False)
				self.Enable(custom_prof_link,False)
			elif id==prof_custom:
				self.Enable(edge_txt,False)
				self.Enable(edge_value,False)
				self.Enable(rad_txt,False)
				self.Enable(rad_value,False)
				self.Enable(rad_inner_value,False)
				self.Enable(rad_inner_txt,False)
				self.Enable(sides_txt,False)
				self.Enable(sides_value,False)
				self.Enable(custom_prof_txt,True)
				self.Enable(custom_prof_link,True)
				
			self.LayoutChanged(group2_settings)
			#c4d.EventAdd()
   
		def CreateLayout(self):
		   #create the layout of the dialog
			self.SetTitle("QuickSweep")
			#PROFILE
			self.GroupBegin(group1_profile, c4d.BFH_SCALEFIT, 2, 5, groupflags=c4d.BFV_GRIDGROUP_EQUALROWS|c4d.BFV_GRIDGROUP_EQUALCOLS)
			self.GroupBorderSpace(10, 10, 10, 10)
			self.AddStaticText(prof_txt, c4d.BFH_LEFT, name="Profile")
			self.AddComboBox(prof_combo, c4d.BFH_SCALEFIT|c4d.BFV_SCALEFIT, inith=20)
			self.AddChild(prof_combo,prof_circle,"Circle&i"+str(c4d.OBJECT_SPLINECIRCLE) + "&")
			self.AddChild(prof_combo,prof_square,"Square&i"+str(c4d.OBJECT_SPLINERECTANGLE) + "&")
			self.AddChild(prof_combo,prof_nside,"N-Side&i"+str(c4d.OBJECT_SPLINENSIDE) + "&")
			self.AddChild(prof_combo,prof_star,"Star&i"+str(c4d.OBJECT_SPLINESTAR) + "&")
			self.AddChild(prof_combo,prof_flower,"Flower&i"+str(c4d.OBJECT_SPLINEFLOWER) + "&")
			self.AddChild(prof_combo,prof_custom,"Custom...&i"+str(c4d.OBJECT_SPLINE) + "&")
			self.GroupEnd()
			#SETTINGS
			self.GroupBegin(group2_settings, c4d.BFH_SCALEFIT, 2, 5, groupflags=c4d.BFV_GRIDGROUP_EQUALROWS|c4d.BFV_GRIDGROUP_EQUALCOLS)
			self.GroupBorderSpace(10, 10, 10, 10)
			self.AddStaticText(rad_txt, c4d.BFH_LEFT, name="Radius")
			self.AddEditNumberArrows(rad_value, c4d.BFH_LEFT)
			self.AddStaticText(rad_inner_txt, c4d.BFH_LEFT, name="Inner Radius")
			self.AddEditNumberArrows(rad_inner_value, c4d.BFH_LEFT)
			self.AddStaticText(sides_txt, c4d.BFH_LEFT, name="Sides/Points")
			self.AddEditNumberArrows(sides_value, c4d.BFH_LEFT)
			self.AddStaticText(edge_txt, c4d.BFH_LEFT, name="Edge Lenght")
			self.AddEditNumberArrows(edge_value, c4d.BFH_LEFT)
			self.AddStaticText(custom_prof_txt, c4d.BFH_LEFT, name="Custom profile")
			self.linkbox = self.AddCustomGui(custom_prof_link, c4d.CUSTOMGUI_LINKBOX, "", c4d.BFH_SCALEFIT|c4d.BFV_SCALEFIT, 0, 0)
			self.GroupEnd()
			#OPTIONS
			self.GroupBegin(group3_options, c4d.BFH_SCALEFIT, 1, 1, groupflags=c4d.BFV_GRIDGROUP_EQUALROWS|c4d.BFV_GRIDGROUP_EQUALCOLS)
			self.GroupBorderSpace(10, 10, 10, 10)
			self.AddCheckbox(keep_source, c4d.BFH_LEFT, initw=0, inith=0, name="Keep original(s)")
			self.AddCheckbox(ctrl_spline, c4d.BFH_LEFT, initw=0, inith=0, name="Make control spline")
			self.AddSeparatorH(inith=0, flags=c4d.BFH_SCALEFIT)
			self.AddButton(set_default, c4d.BFH_LEFT, name="Set as default")
			self.GroupEnd()
			#BUTTONS
			self.GroupBegin(group4_buttons, c4d.BFH_SCALEFIT, 2, 1)
			self.GroupBorderSpace(10, 10, 10, 10)
			global version
			if version >= 13000:
				self.AddDlgGroup(c4d.DLG_CANCEL|c4d.DLG_OK)
			else:
				self.AddButton(btn_canc, c4d.BFH_SCALE, name="CANCEL")
				self.AddButton(btn_ok, c4d.BFH_SCALE, name="OK")
			self.GroupEnd()
			return True
   
		def InitValues(self):
			#initiate the gadgets with defaults values
			#create defaults if not present
			if not plugins.GetWorldPluginData(PLUGIN_ID):
				defaults=c4d.BaseContainer()
				defaults.SetLong(1,prof_circle) #default profile
				defaults.SetReal(2,10) #default radius
				defaults.SetReal(3,5) #default inner radius
				defaults.SetLong(4,8) #default sides
				defaults.SetReal(5,10) #defaults edge
				defaults.SetBool(6,False) #default keep source
				defaults.SetBool(7,False) #default uso ctrl spline
				plugins.SetWorldPluginData(PLUGIN_ID,defaults,add=True) #store defaults
				
			bc = plugins.GetWorldPluginData(PLUGIN_ID)
			def_prof = bc.GetLong(1,preset=prof_circle)
			def_rad = bc.GetReal(2,preset=10)
			def_inner_rad = bc.GetReal(3,preset=5)
			def_sides = bc.GetLong(4,preset=8)
			def_edge = bc.GetReal(5,preset=10)
			def_source = bc.GetBool(6,False)
			def_ctrlSpline = bc.GetBool(7,False)
			
			self.SetLong(prof_combo, def_prof) # PROFILE
			self.SetReal(rad_value, def_rad, min=0, step=0.1) # RADIUS
			self.SetReal(edge_value, def_edge, min=0, step=0.1) # EDGE
			self.SetReal(rad_inner_value, def_inner_rad, min=0, step=0.1) #INNER RADIUS
			self.SetReal(sides_value, def_sides, min=2, step=1) # SIDES
			self.SetBool(keep_source, def_source) #KEEP SOURCE
			self.SetBool(ctrl_spline, def_ctrlSpline) #USE CTRL SPLINE
			global version
			if version >= 13000:
				self.Activate(c4d.IDC_OK)
			else:
				self.Activate(btn_ok)
				
			self.UpdateDlg(self.GetLong(prof_combo))
		   
			return True
   
		def Command(self, id, msg):
			#handle user input
			
			self.UpdateDlg(self.GetLong(prof_combo))
			
			dati = {}
			
			if id==set_default:
				defaults=c4d.BaseContainer()
				defaults.SetLong(1,self.GetLong(prof_combo)) #default profile
				defaults.SetReal(2,self.GetReal(rad_value)) #default radius
				defaults.SetReal(3,self.GetReal(rad_inner_value)) #default inner radius
				defaults.SetLong(4,self.GetLong(sides_value)) #default sides
				defaults.SetReal(5,self.GetReal(edge_value)) #defaults edge
				defaults.SetBool(6,self.GetBool(keep_source)) #default keep source
				defaults.SetBool(7,self.GetBool(ctrl_spline)) #default uso ctrl spline
				plugins.SetWorldPluginData(PLUGIN_ID,defaults,add=True) #store defaults
				
			if id==c4d.IDC_OK or id==btn_ok:
				if self.GetLong(prof_combo)==prof_circle:
					dati['profile_id'] = prof_circle
					dati['rad'] = self.GetReal(rad_value)
					dati['keep_source'] = self.GetBool(keep_source)
					dati['ctrl_spline'] = self.GetBool(ctrl_spline)
					make_sweep(dati)
					self.Close()
				elif self.GetLong(prof_combo)==prof_square:
					dati['profile_id'] = prof_square
					dati['edge'] = self.GetReal(edge_value)
					dati['keep_source'] = self.GetBool(keep_source)
					dati['ctrl_spline'] = self.GetBool(ctrl_spline)
					make_sweep(dati)
					self.Close()
				elif self.GetLong(prof_combo)==prof_nside:
					dati['profile_id'] = prof_nside
					dati['rad'] = self.GetReal(rad_value)
					dati['sides'] = self.GetLong(sides_value)
					dati['keep_source'] = self.GetBool(keep_source)
					dati['ctrl_spline'] = self.GetBool(ctrl_spline)
					make_sweep(dati)
					self.Close()
				elif self.GetLong(prof_combo)==prof_star:
					dati['profile_id'] = prof_star
					dati['rad'] = self.GetReal(rad_value)
					dati['inner_rad'] = self.GetReal(rad_inner_value)
					dati['sides'] = self.GetLong(sides_value)
					dati['keep_source'] = self.GetBool(keep_source)
					dati['ctrl_spline'] = self.GetBool(ctrl_spline)
					make_sweep(dati)
					self.Close()
				elif self.GetLong(prof_combo)==prof_flower:
					dati['profile_id'] = prof_flower
					dati['rad'] = self.GetReal(rad_value)
					dati['inner_rad'] = self.GetReal(rad_inner_value)
					dati['sides'] = self.GetLong(sides_value)
					dati['keep_source'] = self.GetBool(keep_source)
					dati['ctrl_spline'] = self.GetBool(ctrl_spline)
					make_sweep(dati)
					self.Close()
				elif self.GetLong(prof_combo)==prof_custom:
					dati['profile_id'] = prof_custom
					dati['custom_spline'] = self.linkbox.GetLink()
					dati['keep_source'] = self.GetBool(keep_source)
					dati['ctrl_spline'] = self.GetBool(ctrl_spline)
					
					if not dati['custom_spline']:
						gui.MessageDialog("Drag or select a spline for 'Custom Profile' field")
					#elif not checkSelected(dati['custom_spline']):
					elif not IsSpline(dati['custom_spline']):
						gui.MessageDialog("Only splines are allowed as custom profile")
					else:
						make_sweep(dati)
						self.Close()
				
				
			elif id==c4d.IDC_CANCEL or id==btn_canc:
				self.Close()
				return False
			return True
	   
	   
	

#PLUGIN CLASS

class QUICKSWEEP(plugins.CommandData):
	 
	dialog = None

	def Execute(self, doc):

		obj_list = doc.GetActiveObjects(0)
		
		if checkSelected(obj_list) == "error":
			gui.MessageDialog("At least one spline must be selected")
			return False
		elif not checkSelected(obj_list):
			gui.MessageDialog("Only splines can be selected")
			return False
		else:
			global splineList
			splineList = obj_list
			if self.dialog is None:
		   		self.dialog = QuickSweepDlg()
			return self.dialog.Open(c4d.DLG_TYPE_ASYNC, defaultw=300, defaulth=50) # ASYNC = floating, MODAL = dialogo standard

		return True
	
	def RestoreLayout(self, sec_ref):
        # manage nonmodal dialog
		if self.dialog is None:
			self.dialog = QuickSweepDlg()
            
		return self.dialog.Restore(pluginid=PLUGIN_ID, secret=sec_ref)

	 

if __name__ == "__main__":
		
	# load icon.tif from res into bmp 
	bmp = bitmaps.BaseBitmap() 
	dir, file = os.path.split(__file__) 
	fn = os.path.join(dir, "res", "QuickSweep.tif") 
	bmp.InitWith(fn) 
	# register the plugin 

	okyn = plugins.RegisterCommandPlugin(id=PLUGIN_ID, str="QuickSweep 1.2b", info=c4d.PLUGINFLAG_COMMAND_HOTKEY, icon=bmp, help="Quick sweep multiple splines", dat=QUICKSWEEP())
	print ""
	print "-------------- QuickSweep 1.2b by Visualtricks ----------------"
	if okyn:
		print "QuickSweep 1.2b initialized "
	else:
		print "Something went wrong - QuickSweep could not initialize"
	print "----------------------------------------------------------"
	print ""